package com.xk72.charles.export;

import com.xk72.charles.export.criY;
import com.xk72.charles.export.zwQH;
import com.xk72.charles.model.Session;
import com.xk72.charles.model.Transaction;
import com.xk72.proxy.ProxyEventStatus;
import com.xk72.proxy.ProxyException;
import com.xk72.proxy.http.HttpFields;
import com.xk72.proxy.http2.Http2Fields;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.net.InetAddress;
import java.time.format.DateTimeParseException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.logging.Logger;

public class SessionTraceImporter implements zwQH {

   private static final Logger FwRs = Logger.getLogger("com.xk72.charles.export.SessionTraceImporter");
   private String GSXJ;
   private String InuZ;
   private byte[] Gwbn;
   private com.xk72.proxy.io.zwQH Wczh;
   private int KRBh;
   private final byte[] VdwQ = new byte[8192];
   private static final Class[] hndF = new Class[]{String.class};


   public static void main(String[] var0) {
      File var2 = new File("/Users/karlvr/export5.trace");
      (new SessionTraceImporter()).FwRs(var2, (Session)null);
   }

   public final Session FwRs(File var1, Session var2) {
      this.Wczh = new com.xk72.proxy.io.zwQH(new BufferedInputStream(new FileInputStream(var1)));
      this.KRBh = 1;
      ArrayList var9 = new ArrayList();
      boolean var3 = true;
      Transaction var4 = null;

      for(String var5 = this.Wczh.c_(); var5 != null; var5 = this.Wczh.c_()) {
         this.FwRs((String)var5);
         if(this.GSXJ != null) {
            if(var3) {
               if(this.GSXJ.equals("HTTP-Trace-Version")) {
                  if(this.InuZ == null) {
                     throw new IOException("版本头无效");
                  }

                  if(this.InuZ.compareTo("1.0") > 0) {
                     throw new IOException(this.InuZ);
                  }
               }
            } else {
               if(var4 == null) {
                  (var4 = new Transaction()).setStatus(ProxyEventStatus.WDwv);
                  var9.add(var4);
               }

               try {
                  if(this.GSXJ.equals("方法")) {
                     var4.setMethod(this.InuZ);
                  } else if(this.GSXJ.equals("协议版本")) {
                     var4.setProtocolVersion(this.InuZ);
                  } else if(this.GSXJ.equals("协议")) {
                     var4.setProtocol(this.InuZ);
                  } else if(this.GSXJ.equals("Host")) {
                     var4.setHost(this.InuZ);
                  } else if(this.GSXJ.equals("端口")) {
                     var4.setPort(Integer.parseInt(this.InuZ));
                  } else if(this.GSXJ.equals("文件")) {
                     var4.setFile(this.InuZ);
                  } else if(this.GSXJ.equals("远程地址")) {
                     var4.setRemoteAddress(InetAddress.getByName(this.InuZ));
                  } else if(this.GSXJ.equals("客户端地址")) {
                     var4.setClientAddress(InetAddress.getByName(this.InuZ));
                  } else if(this.GSXJ.equals("开始时间")) {
                     var4.setStartTime(criY.FwRs((String)this.InuZ));
                  } else if(this.GSXJ.equals("DNS持续时间")) {
                     var4.setDnsDuration(Long.valueOf(Long.parseLong(this.InuZ)));
                  } else if(this.GSXJ.equals("连接持续时间")) {
                     var4.setConnectDuration(Long.valueOf(Long.parseLong(this.InuZ)));
                  } else if(this.GSXJ.equals("请求开始时间")) {
                     var4.setRequestBeginTime(criY.FwRs((String)this.InuZ));
                  } else if(this.GSXJ.equals("请求时间")) {
                     var4.setRequestCompleteTime(criY.FwRs((String)this.InuZ));
                  } else if(this.GSXJ.equals("响应时间")) {
                     var4.setResponseBeginTime(criY.FwRs((String)this.InuZ));
                  } else if(this.GSXJ.equals("结束时间")) {
                     var4.setEndTime(criY.FwRs((String)this.InuZ));
                  } else if(this.GSXJ.equals("请求头大小")) {
                     var4.setRequestHeaderSize(Integer.parseInt(this.InuZ));
                  } else if(this.GSXJ.equals("响应头大小")) {
                     var4.setResponseHeaderSize(Integer.parseInt(this.InuZ));
                  } else if(this.GSXJ.equals("请求体大小")) {
                     var4.setRequestSize((long)Integer.parseInt(this.InuZ));
                  } else if(this.GSXJ.equals("响应体大小")) {
                     var4.setResponseSize((long)Integer.parseInt(this.InuZ));
                  } else if(this.GSXJ.equals("异常")) {
                     var4.setException(GSXJ(this.InuZ));
                     var4.setStatus(ProxyEventStatus.ZcdI);
                  } else if(this.GSXJ.equals("请求体已解码")) {
                     var4.setRequestBodyDecoded(Boolean.valueOf(this.InuZ).booleanValue());
                  } else if(this.GSXJ.equals("响应体已解码")) {
                     var4.setResponseBodyDecoded(Boolean.valueOf(this.InuZ).booleanValue());
                  } else if(this.GSXJ.equals("请求头")) {
                     var4.setRequestHeader(FwRs(this.Gwbn, true, var4.getProtocolVersion()));
                  } else if(this.GSXJ.equals("响应头")) {
                     var4.setResponseHeader(FwRs(this.Gwbn, false, var4.getProtocolVersion()));
                  } else if(this.GSXJ.equals("请求体")) {
                     var4.setRequestBody(this.Gwbn);
                  } else if(this.GSXJ.equals("响应体")) {
                     var4.setResponseBody(this.Gwbn);
                  } else {
                     FwRs.warning(this.GSXJ);
                  }
               } catch (DateTimeParseException var8) {
                  IOException var10001 = new IOException;
                  this.KRBh.<init>(var5, var8);
                  throw var10001;
               }
            }
         } else if(var3) {
            var3 = false;
         } else {
            var4 = null;
         }

         ++this.KRBh;
      }

      if((var2 = var2) == null) {
         var2 = new Session();
      }

      Iterator var10 = var9.iterator();

      while(var10.hasNext()) {
         Transaction var11 = (Transaction)var10.next();
         var2.addTransaction(var11);
      }

      return var2;
   }

   private void FwRs(Transaction var1) {
      if(this.GSXJ.equals("方法")) {
         var1.setMethod(this.InuZ);
      } else if(this.GSXJ.equals("协议版本")) {
         var1.setProtocolVersion(this.InuZ);
      } else if(this.GSXJ.equals("协议")) {
         var1.setProtocol(this.InuZ);
      } else if(this.GSXJ.equals("Host")) {
         var1.setHost(this.InuZ);
      } else if(this.GSXJ.equals("端口")) {
         var1.setPort(Integer.parseInt(this.InuZ));
      } else if(this.GSXJ.equals("文件")) {
         var1.setFile(this.InuZ);
      } else if(this.GSXJ.equals("远程地址")) {
         var1.setRemoteAddress(InetAddress.getByName(this.InuZ));
      } else if(this.GSXJ.equals("客户端地址")) {
         var1.setClientAddress(InetAddress.getByName(this.InuZ));
      } else if(this.GSXJ.equals("开始时间")) {
         var1.setStartTime(criY.FwRs((String)this.InuZ));
      } else if(this.GSXJ.equals("DNS持续时间")) {
         var1.setDnsDuration(Long.valueOf(Long.parseLong(this.InuZ)));
      } else if(this.GSXJ.equals("连接持续时间")) {
         var1.setConnectDuration(Long.valueOf(Long.parseLong(this.InuZ)));
      } else if(this.GSXJ.equals("请求开始时间")) {
         var1.setRequestBeginTime(criY.FwRs((String)this.InuZ));
      } else if(this.GSXJ.equals("请求时间")) {
         var1.setRequestCompleteTime(criY.FwRs((String)this.InuZ));
      } else if(this.GSXJ.equals("响应时间")) {
         var1.setResponseBeginTime(criY.FwRs((String)this.InuZ));
      } else if(this.GSXJ.equals("结束时间")) {
         var1.setEndTime(criY.FwRs((String)this.InuZ));
      } else if(this.GSXJ.equals("请求头大小")) {
         var1.setRequestHeaderSize(Integer.parseInt(this.InuZ));
      } else if(this.GSXJ.equals("响应头大小")) {
         var1.setResponseHeaderSize(Integer.parseInt(this.InuZ));
      } else if(this.GSXJ.equals("请求体大小")) {
         var1.setRequestSize((long)Integer.parseInt(this.InuZ));
      } else if(this.GSXJ.equals("响应体大小")) {
         var1.setResponseSize((long)Integer.parseInt(this.InuZ));
      } else if(this.GSXJ.equals("异常")) {
         var1.setException(GSXJ(this.InuZ));
         var1.setStatus(ProxyEventStatus.ZcdI);
      } else if(this.GSXJ.equals("请求体已解码")) {
         var1.setRequestBodyDecoded(Boolean.valueOf(this.InuZ).booleanValue());
      } else if(this.GSXJ.equals("响应体已解码")) {
         var1.setResponseBodyDecoded(Boolean.valueOf(this.InuZ).booleanValue());
      } else if(this.GSXJ.equals("请求头")) {
         var1.setRequestHeader(FwRs(this.Gwbn, true, var1.getProtocolVersion()));
      } else if(this.GSXJ.equals("响应头")) {
         var1.setResponseHeader(FwRs(this.Gwbn, false, var1.getProtocolVersion()));
      } else if(this.GSXJ.equals("请求体")) {
         var1.setRequestBody(this.Gwbn);
      } else if(this.GSXJ.equals("响应体")) {
         var1.setResponseBody(this.Gwbn);
      } else {
         FwRs.warning(this.GSXJ);
      }
   }

   private void FwRs(String var1) {
      if((var1 = com.xk72.proxy.io.zwQH.FwRs(var1, "UTF-8")).length() > 0) {
         int var2 = var1.indexOf(58);

         IOException var10001;
         try {
            this.GSXJ = var1.substring(0, var2);
            if(var1.charAt(var2 + 1) == 32) {
               this.InuZ = var1.substring(var2 + 2);
               this.Gwbn = null;
            } else {
               if(var1.charAt(var2 + 1) != 60 || var1.charAt(var2 + 2) != 60) {
                  var10001 = new IOException;
                  this.KRBh.<init>(var1);
                  throw var10001;
               }

               String var8;
               byte[] var3 = com.xk72.proxy.io.zwQH.GSXJ(var8 = var1.substring(var2 + 3));
               this.InuZ = null;
               ByteArrayOutputStream var4 = new ByteArrayOutputStream(8192);

               for(int var5 = this.Wczh.FwRs(this.VdwQ, 0, 8192); var5 != -1; var5 = this.Wczh.FwRs(this.VdwQ, 0, 8192)) {
                  if(FwRs(this.VdwQ, 0, var5, var3, 0, var3.length)) {
                     this.Wczh.unread(this.VdwQ, 0, var5);
                     break;
                  }

                  var4.write(this.VdwQ, 0, var5);
               }

               this.Gwbn = var4.toByteArray();
               if(!(var1 = this.Wczh.c_()).trim().equals(var8)) {
                  var10001 = new IOException;
                  this.KRBh.<init>(var1);
                  throw var10001;
               }
            }

         } catch (StringIndexOutOfBoundsException var6) {
            var10001 = new IOException;
            this.KRBh.<init>(var1);
            throw var10001;
         } catch (NumberFormatException var7) {
            var10001 = new IOException;
            this.KRBh.<init>(var1);
            throw var10001;
         }
      } else {
         this.GSXJ = null;
      }
   }

   private static boolean FwRs(byte[] var0, int var1, int var2, byte[] var3, int var4, int var5) {
      if(var2 < var5) {
         return false;
      } else {
         for(var1 = 0; var1 < var5; ++var1) {
            if(var0[var1 + 0] != var3[var1 + 0]) {
               return false;
            }
         }

         return true;
      }
   }

   private static HttpFields FwRs(byte[] var0, boolean var1, String var2) {
      com.xk72.proxy.io.zwQH var5 = new com.xk72.proxy.io.zwQH(new ByteArrayInputStream(var0));

      Object var6;
      try {
         Object var7;
         if("HTTP/2.0".equals(var2)) {
            var7 = new Http2Fields();
         } else {
            var7 = new HttpFields();
         }

         ((HttpFields)var7).read(var5, var1);
         var6 = var7;
      } catch (Throwable var4) {
         try {
            var5.close();
         } catch (Throwable var3) {
            var4.addSuppressed(var3);
         }

         throw var4;
      }

      var5.close();
      return (HttpFields)var6;
   }

   private static Exception GSXJ(String var0) {
      int var1 = var0.indexOf(": ");

      try {
         if(var1 != -1) {
            Class var2 = Class.forName(var0.substring(0, var1));
            if(var1 + 2 < var0.length()) {
               String var9 = var0.substring(var1 + 2);
               return (Exception)var2.getConstructor(hndF).newInstance(new Object[]{var9});
            }

            return (Exception)var2.getDeclaredConstructor(new Class[0]).newInstance(new Object[0]);
         }
      } catch (ClassNotFoundException var3) {
         ;
      } catch (NoSuchMethodException var4) {
         ;
      } catch (IllegalArgumentException var5) {
         ;
      } catch (InstantiationException var6) {
         ;
      } catch (IllegalAccessException var7) {
         ;
      } catch (InvocationTargetException var8) {
         ;
      }

      return new ProxyException(var0);
   }

}
